from typing import List

from minieval.datatypes import Response
from minieval.extract.math_latex import is_equiv


class passAtK:
    def __init__(self, ks: List[int]):
        self.ks = ks

    def grade_responses(self, responses: List[Response]):
        self.instance_scores = list(map(self._grade_response, responses))
        return self.instance_scores

    def compute_metric(self) -> float:
        if self.instance_scores is None:
            raise ValueError("Need to grade instances before computing dataset-level metric!")
        return sum(self.instance_scores) / len(self.instance_scores)

    def _grade_response(self, response: Response) -> bool:
        responses = response.output.extracted_answer
        correct = response.input.solution

        assert correct is not None

        # "math flex" will allow any extracted answer to be correct
        for gen in responses:
            if is_equiv(gen, correct):
                return True

        return False


# TODO: pass@k, maj@k (acc is a special case)

# The metrics also need to know when there are subsets, and report macro / micro averages.
